*** ./plugins/org.eclipse.platform.source.sysv5.gtk.x86/src/org.eclipse.update.core.sysv5_3.1.0/src/update.c.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.platform.source.sysv5.gtk.x86/src/org.eclipse.update.core.sysv5_3.1.0/src/update.c	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,164 ----
+ /**********************************************************************
+  * Copyright (c) 2000, 2005 IBM Corporation and others.
+  * All rights reserved. This program and the accompanying materials
+  * are made available under the terms of the Eclipse Public License v1.0
+  * which accompanies this distribution, and is available at
+  * http://www.eclipse.org/legal/epl-v10.html
+  *
+  * Contributors:
+  *    IBM Corporation - Initial API and implementation
+  **********************************************************************/
+ 
+ /* bug 82520 : need to include stdlib.h */
+ # include <stdlib.h>
+ # include <sys/types.h>
+ # include <sys/statfs.h>
+ # include <update.h>
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeGetFreeSpace
+  * Signature: (Ljava/io/File;)J
+  */
+ JNIEXPORT jlong JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeGetFreeSpace(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass,
+ 	jobject file) {
+ 
+ 	// to retrive the String
+ 	jclass cls;
+ 	jmethodID id;
+ 	jobject obj;
+ 
+ 	// java.io.File.getAbsolutePath()
+ 	const char * lpDirectoryName;
+ 
+ 	// Parameters
+ 	struct statfs buffer;
+ 
+ 	// the result
+ 	jlong result = org_eclipse_update_configuration_LocalSystemInfo_SIZE_UNKNOWN;
+ 
+ 	cls = (*jnienv) -> GetObjectClass(jnienv, file);
+ 	id = (*jnienv) -> GetMethodID(jnienv, cls, "getAbsolutePath", "()Ljava/lang/String;");
+ 	obj = (*jnienv) -> CallObjectMethod(jnienv, file, id);
+ 	lpDirectoryName = (*jnienv) -> GetStringUTFChars(jnienv, (jstring) obj, 0);
+ 
+ 	// cast one argument as jlong to have a jlong result
+ 	int err = statfs(lpDirectoryName,&buffer);
+ 	if (err==0){
+ 		long size = buffer.f_bsize;
+ 		jlong free = buffer.f_bfree;
+ 		result = size*free;
+ 	}
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeGetLabel
+  * Signature: (Ljava/io/File;)Ljava/lang/String;
+  */
+ JNIEXPORT jstring JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeGetLabel(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass,
+ 	jobject file) {
+ 
+ 	// to retrive the String
+ 	jclass cls;
+ 	jmethodID id;
+ 	jobject obj;
+ 
+ 	// java.io.File.getAbsolutePath()
+ 	const char * lpDirectoryName;
+ 
+ 	// obtain the String from the parameter
+ 	cls = (*jnienv) -> GetObjectClass(jnienv, file);
+ 	id = (*jnienv) -> GetMethodID(jnienv, cls, "getAbsolutePath", "()Ljava/lang/String;");
+ 	obj = (*jnienv) -> CallObjectMethod(jnienv, file, id);
+ 	lpDirectoryName = (*jnienv) -> GetStringUTFChars(jnienv, (jstring) obj, 0);
+ 
+ 	jstring result = NULL;
+ 
+ 	// implementation following
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeGetType
+  * Signature: (Ljava/io/File;)I
+  */
+ JNIEXPORT jint JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeGetType(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass,
+ 	jobject file) {
+ 
+ 	// to retrive the String
+ 	jclass cls;
+ 	jmethodID id;
+ 	jobject obj;
+ 
+ 	// java.io.File.getAbsolutePath()
+ 	const char * lpDirectoryName;
+ 
+ 	// obtain the String from the parameter
+ 	cls = (*jnienv) -> GetObjectClass(jnienv, file);
+ 	id = (*jnienv) -> GetMethodID(jnienv, cls, "getAbsolutePath", "()Ljava/lang/String;");
+ 	obj = (*jnienv) -> CallObjectMethod(jnienv, file, id);
+ 	lpDirectoryName = (*jnienv) -> GetStringUTFChars(jnienv, (jstring) obj, 0);
+ 
+ 	int result;
+ 	
+ 	// implemantation
+ 
+ 	result = org_eclipse_update_configuration_LocalSystemInfo_VOLUME_INVALID_PATH;
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeListMountPoints
+  * Signature: ()[Ljava/lang/String;
+  */
+ JNIEXPORT jobjectArray JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeListMountPoints(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass) {
+ 
+ 	//
+ 	int drive;
+ 	char driveName[100];
+ 	jobjectArray returnArray;
+ 	int nDrive = 0;
+ 
+ 	// 
+ 	jclass stringClass;
+ 	jobject empty;
+ 	int index = 0;
+ 	jobject str;
+ 
+ 	// implementation
+ 	// find mount points
+ 
+ 	drive = 0;
+ 	stringClass = (*jnienv) -> FindClass(jnienv, "java/lang/String");
+ 	empty = (*jnienv) -> NewStringUTF(jnienv, "");
+ 	//returnArray = (*jnienv) -> NewObjectArray(jnienv, nDrive, stringClass, empty);
+ 
+ 	// for now return null as method is not implemented
+ 	returnArray = NULL;
+ 
+ 	int i;
+ 	for (i = 0; i < drive; i++) {
+ 		// implementation, create String for each mount point
+ 
+ 		str = (*jnienv) -> NewStringUTF(jnienv, driveName);
+ 		(*jnienv) -> SetObjectArrayElement(jnienv, returnArray, index, str);
+ 
+ 		index++;
+ 	}
+ 
+ 	return returnArray;
+ }
*** ./plugins/org.eclipse.rcp.source.sysv5.gtk.x86/META-INF/MANIFEST.MF.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.rcp.source.sysv5.gtk.x86/META-INF/MANIFEST.MF	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,7 ----
+ Manifest-Version: 1.0
+ Bundle-Name: %pluginName
+ Bundle-SymbolicName: org.eclipse.rcp.source.sysv5.gtk.x86; singleton=true
+ Bundle-Version: 3.2.1
+ Fragment-Host: org.eclipse.rcp.source;bundle-version="3.2.1"
+ Bundle-Localization: plugin
+ Bundle-Vendor: %providerName
*** ./plugins/org.eclipse.update.core.sysv5/src/update.c.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.update.core.sysv5/src/update.c	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,164 ----
+ /**********************************************************************
+  * Copyright (c) 2000, 2005 IBM Corporation and others.
+  * All rights reserved. This program and the accompanying materials
+  * are made available under the terms of the Eclipse Public License v1.0
+  * which accompanies this distribution, and is available at
+  * http://www.eclipse.org/legal/epl-v10.html
+  *
+  * Contributors:
+  *    IBM Corporation - Initial API and implementation
+  **********************************************************************/
+ 
+ /* bug 82520 : need to include stdlib.h */
+ # include <stdlib.h>
+ # include <sys/types.h>
+ # include <sys/statfs.h>
+ # include <update.h>
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeGetFreeSpace
+  * Signature: (Ljava/io/File;)J
+  */
+ JNIEXPORT jlong JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeGetFreeSpace(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass,
+ 	jobject file) {
+ 
+ 	// to retrive the String
+ 	jclass cls;
+ 	jmethodID id;
+ 	jobject obj;
+ 
+ 	// java.io.File.getAbsolutePath()
+ 	const char * lpDirectoryName;
+ 
+ 	// Parameters
+ 	struct statfs buffer;
+ 
+ 	// the result
+ 	jlong result = org_eclipse_update_configuration_LocalSystemInfo_SIZE_UNKNOWN;
+ 
+ 	cls = (*jnienv) -> GetObjectClass(jnienv, file);
+ 	id = (*jnienv) -> GetMethodID(jnienv, cls, "getAbsolutePath", "()Ljava/lang/String;");
+ 	obj = (*jnienv) -> CallObjectMethod(jnienv, file, id);
+ 	lpDirectoryName = (*jnienv) -> GetStringUTFChars(jnienv, (jstring) obj, 0);
+ 
+ 	// cast one argument as jlong to have a jlong result
+ 	int err = statfs(lpDirectoryName,&buffer);
+ 	if (err==0){
+ 		long size = buffer.f_bsize;
+ 		jlong free = buffer.f_bfree;
+ 		result = size*free;
+ 	}
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeGetLabel
+  * Signature: (Ljava/io/File;)Ljava/lang/String;
+  */
+ JNIEXPORT jstring JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeGetLabel(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass,
+ 	jobject file) {
+ 
+ 	// to retrive the String
+ 	jclass cls;
+ 	jmethodID id;
+ 	jobject obj;
+ 
+ 	// java.io.File.getAbsolutePath()
+ 	const char * lpDirectoryName;
+ 
+ 	// obtain the String from the parameter
+ 	cls = (*jnienv) -> GetObjectClass(jnienv, file);
+ 	id = (*jnienv) -> GetMethodID(jnienv, cls, "getAbsolutePath", "()Ljava/lang/String;");
+ 	obj = (*jnienv) -> CallObjectMethod(jnienv, file, id);
+ 	lpDirectoryName = (*jnienv) -> GetStringUTFChars(jnienv, (jstring) obj, 0);
+ 
+ 	jstring result = NULL;
+ 
+ 	// implementation following
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeGetType
+  * Signature: (Ljava/io/File;)I
+  */
+ JNIEXPORT jint JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeGetType(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass,
+ 	jobject file) {
+ 
+ 	// to retrive the String
+ 	jclass cls;
+ 	jmethodID id;
+ 	jobject obj;
+ 
+ 	// java.io.File.getAbsolutePath()
+ 	const char * lpDirectoryName;
+ 
+ 	// obtain the String from the parameter
+ 	cls = (*jnienv) -> GetObjectClass(jnienv, file);
+ 	id = (*jnienv) -> GetMethodID(jnienv, cls, "getAbsolutePath", "()Ljava/lang/String;");
+ 	obj = (*jnienv) -> CallObjectMethod(jnienv, file, id);
+ 	lpDirectoryName = (*jnienv) -> GetStringUTFChars(jnienv, (jstring) obj, 0);
+ 
+ 	int result;
+ 	
+ 	// implemantation
+ 
+ 	result = org_eclipse_update_configuration_LocalSystemInfo_VOLUME_INVALID_PATH;
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_update_configuration_LocalSystemInfo
+  * Method:    nativeListMountPoints
+  * Signature: ()[Ljava/lang/String;
+  */
+ JNIEXPORT jobjectArray JNICALL Java_org_eclipse_update_configuration_LocalSystemInfo_nativeListMountPoints(
+ 	JNIEnv * jnienv,
+ 	jclass javaClass) {
+ 
+ 	//
+ 	int drive;
+ 	char driveName[100];
+ 	jobjectArray returnArray;
+ 	int nDrive = 0;
+ 
+ 	// 
+ 	jclass stringClass;
+ 	jobject empty;
+ 	int index = 0;
+ 	jobject str;
+ 
+ 	// implementation
+ 	// find mount points
+ 
+ 	drive = 0;
+ 	stringClass = (*jnienv) -> FindClass(jnienv, "java/lang/String");
+ 	empty = (*jnienv) -> NewStringUTF(jnienv, "");
+ 	//returnArray = (*jnienv) -> NewObjectArray(jnienv, nDrive, stringClass, empty);
+ 
+ 	// for now return null as method is not implemented
+ 	returnArray = NULL;
+ 
+ 	int i;
+ 	for (i = 0; i < drive; i++) {
+ 		// implementation, create String for each mount point
+ 
+ 		str = (*jnienv) -> NewStringUTF(jnienv, driveName);
+ 		(*jnienv) -> SetObjectArrayElement(jnienv, returnArray, index, str);
+ 
+ 		index++;
+ 	}
+ 
+ 	return returnArray;
+ }
*** ./plugins/org.eclipse.update.core.sysv5/META-INF/MANIFEST.MF.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.update.core.sysv5/META-INF/MANIFEST.MF	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,9 ----
+ Manifest-Version: 1.0
+ Bundle-ManifestVersion: 2
+ Bundle-Name: %fragmentNameSysv5
+ Bundle-SymbolicName: org.eclipse.update.core.sysv5
+ Bundle-Version: 3.1.0
+ Bundle-Vendor: %providerName
+ Fragment-Host: org.eclipse.update.core;bundle-version="[3.0.0,4.0.0)"
+ Bundle-Localization: plugin
+ Eclipse-PlatformFilter: (osgi.os=sysv5)
*** ./plugins/org.eclipse.update.core.sysv5/.classpath.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.update.core.sysv5/.classpath	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,7 ----
+ <?xml version="1.0" encoding="UTF-8"?>
+ <classpath>
+ 	<classpathentry kind="src" path="src"/>
+ 	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins"/>
+ 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+ 	<classpathentry kind="output" path="bin"/>
+ </classpath>
*** ./plugins/org.eclipse.update.core.sysv5/.project.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.update.core.sysv5/.project	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,33 ----
+ <?xml version="1.0" encoding="UTF-8"?>
+ <projectDescription>
+ 	<name>org.eclipse.update.core.sysv5</name>
+ 	<comment></comment>
+ 	<projects>
+ 		<project>org.eclipse.core.boot</project>
+ 		<project>org.eclipse.core.runtime</project>
+ 		<project>org.eclipse.core.runtime.compatibility</project>
+ 		<project>org.eclipse.update.configurator</project>
+ 		<project>org.eclipse.update.core</project>
+ 	</projects>
+ 	<buildSpec>
+ 		<buildCommand>
+ 			<name>org.eclipse.jdt.core.javabuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 		<buildCommand>
+ 			<name>org.eclipse.pde.ManifestBuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 		<buildCommand>
+ 			<name>org.eclipse.pde.SchemaBuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 	</buildSpec>
+ 	<natures>
+ 		<nature>org.eclipse.jdt.core.javanature</nature>
+ 		<nature>org.eclipse.pde.PluginNature</nature>
+ 	</natures>
+ </projectDescription>
*** ./plugins/org.eclipse.core.resources.sysv5/src/core.c.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.core.resources.sysv5/src/core.c	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,289 ----
+ /*******************************************************************************
+  * Copyright (c) 2000, 2001, 2004 IBM Corporation and others.
+  * All rights reserved. This program and the accompanying materials 
+  * are made available under the terms of the Eclipse Public License v1.0
+  * which accompanies this distribution, and is available at
+  * http://www.eclipse.org/legal/epl-v10.html
+  * 
+  * Contributors:
+  *     IBM Corporation - initial API and implementation
+  *     Red Hat Incorporated - get/setResourceAttribute code
+  *******************************************************************************/
+ #include <jni.h>
+ #include <sys/types.h>
+ #include <sys/stat.h>
+ #include <utime.h>
+ #include <stdlib.h>
+ #include <string.h>
+ #include "core.h"
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalIsUnicode
+  * Signature: ()Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalIsUnicode
+   (JNIEnv *env, jclass clazz) {
+   	// no specific support for Unicode-based file names
+ 	return JNI_FALSE;
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalGetStatW
+  * Signature: ([C)J
+  */
+ JNIEXPORT jlong JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalGetStatW
+    (JNIEnv *env, jclass clazz, jcharArray target) {
+ 	// shouldn't ever be called - there is no Unicode-specific calls
+ 	return JNI_FALSE;
+ }   
+ 
+ /*
+  * Get a null-terminated byte array from a java byte array.
+  * The returned bytearray needs to be freed whe not used
+  * anymore. Use free(result) to do that.
+  */
+ jbyte* getByteArray(JNIEnv *env, jbyteArray target) {
+ 	jsize n;
+ 	jbyte *temp, *result;
+ 	
+ 	temp = (*env)->GetByteArrayElements(env, target, 0);
+ 	n = (*env)->GetArrayLength(env, target);
+ 	result = malloc((n+1) * sizeof(jbyte));
+ 	memcpy(result, temp, n);
+ 	result[n] = '\0';
+ 	(*env)->ReleaseByteArrayElements(env, target, temp, 0);
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalGetStat
+  * Signature: ([B)J
+  */
+ JNIEXPORT jlong JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalGetStat
+    (JNIEnv *env, jclass clazz, jbyteArray target) {
+ 
+ 	struct stat info;
+ 	jlong result;
+ 	jint code;
+ 	jbyte *name;
+ 
+ 	/* get stat */
+ 	name = getByteArray(env, target);
+ 	code = stat(name, &info);
+ 	free(name);
+ 
+ 	/* test if an error occurred */
+ 	if (code == -1)
+ 	  return 0;
+ 
+ 	/* filter interesting bits */
+ 	/* lastModified */
+ 	result = ((jlong) info.st_mtime) * 1000; /* lower bits */
+ 	/* valid stat */
+ 	result |= STAT_VALID;
+ 	/* is folder? */
+ 	if ((info.st_mode & S_IFDIR) == S_IFDIR)
+ 		result |= STAT_FOLDER;
+ 	/* is read-only? */
+ 	if ((info.st_mode & S_IWRITE) != S_IWRITE)
+ 		result |= STAT_READ_ONLY;
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalCopyAttributes
+  * Signature: ([B[BZ)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalCopyAttributes
+ (JNIEnv *env, jclass clazz, jbyteArray source, jbyteArray destination, jboolean copyLastModified) {
+ 
+   struct stat info;
+   struct utimbuf ut;
+   jbyte *sourceFile, *destinationFile;
+   jint code;
+ 
+   sourceFile = getByteArray(env, source);
+   destinationFile = getByteArray(env, destination);
+ 
+   code = stat(sourceFile, &info);
+   if (code == 0) {
+     code = chmod(destinationFile, info.st_mode);
+     if (code == 0 && copyLastModified) {
+       ut.actime = info.st_atime;
+       ut.modtime = info.st_mtime;
+       code = utime(destinationFile, &ut);
+     }
+   }
+ 
+   free(sourceFile);
+   free(destinationFile);
+   return code != -1;
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalCopyAttributesW
+  * Signature: ([C[CZ)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalCopyAttributesW
+   (JNIEnv *env, jclass clazz, jcharArray source, jcharArray destination, jboolean copyLastModified) {
+ 	// shouldn't ever be called - there is no Unicode-specific calls
+ 	return JNI_FALSE;   
+ }
+ 
+ 
+ /*
+  * Class:     org_eclipse_ant_core_EclipseProject
+  * Method:    internalCopyAttributes
+  * Signature: ([B[BZ)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_ant_core_EclipseFileUtils_internalCopyAttributes
+    (JNIEnv *env, jclass clazz, jbyteArray source, jbyteArray destination, jboolean copyLastModified) {
+ 
+   /* use the same implementation for both methods */
+   return Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalCopyAttributes
+     (env, clazz, source, destination, copyLastModified);
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalSetResourceAttributesW
+  * Signature: ([CLorg/eclipse/core/resources/ResourceAttributes;)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalSetResourceAttributesW
+   (JNIEnv *env, jclass clazz, jcharArray target, jobject obj) {
+ 	// shouldn't ever be called - there is no Unicode-specific calls
+ 	return JNI_FALSE;   
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalSetResourceAttributes
+  * Signature: ([BLorg/eclipse/core/resources/ResourceAttributes;)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalSetResourceAttributes
+   (JNIEnv *env, jclass clazz, jcharArray target, jobject obj) {
+ 
+     int mask;
+     struct stat info;
+     jbyte *name;
+     jint code;
+     jmethodID mid;
+     jboolean executable, readOnly;
+     jclass cls;
+     
+     /* find out if we need to set the execute bit */
+     cls = (*env)->GetObjectClass(env, obj);
+     mid = (*env)->GetMethodID(env, cls, "isExecutable", "()Z");
+     if (mid == 0)
+ 		return JNI_FALSE;
+     executable = (*env)->CallBooleanMethod(env, obj, mid);
+     
+     /* find out if we need to set the readonly bits */
+     mid = (*env)->GetMethodID(env, cls, "isReadOnly", "()Z");
+     if (mid == 0)
+ 		return JNI_FALSE;
+     readOnly = (*env)->CallBooleanMethod(env, obj, mid);
+     
+     /* get the current permissions */
+     name = getByteArray(env, target);
+     code = stat(name, &info);
+     
+     /* create the mask */
+     mask = S_IRUSR |
+ 	       S_IWUSR |
+ 	       S_IXUSR |
+            S_IRGRP |
+            S_IWGRP |
+            S_IXGRP |
+            S_IROTH |
+            S_IWOTH |
+            S_IXOTH;
+     mask &= info.st_mode;
+     if (executable)
+ 	    mask |= S_IXUSR;
+     else
+ 	    mask &= ~(S_IXUSR | S_IXGRP | S_IXOTH);
+ 	if (readOnly)
+ 	    mask &= ~(S_IWUSR | S_IWGRP | S_IWOTH);
+ 	else
+ 	    mask |= (S_IRUSR | S_IWUSR);
+     
+     /* write the permissions */
+     code = chmod(name, mask);
+ 
+     free(name);
+     return code != -1;
+ 
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalGetResourceAttributesW
+  * Signature: ([CLorg/eclipse/core/resources/ResourceAttributes;)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalGetResourceAttributesW
+   (JNIEnv *env, jclass clazz, jcharArray target, jobject obj) {
+ 	// shouldn't ever be called - there is no Unicode-specific calls
+ 	return JNI_FALSE;   
+ }
+ 
+ /*
+  * Class:     org_eclipse_core_internal_localstore_CoreFileSystemLibrary
+  * Method:    internalGetResourceAttributes
+  * Signature: ([BLorg/eclipse/core/resources/ResourceAttributes;)Z
+  */
+ JNIEXPORT jboolean JNICALL Java_org_eclipse_core_internal_localstore_CoreFileSystemLibrary_internalGetResourceAttributes
+   (JNIEnv *env, jclass clazz, jcharArray target, jobject obj) {
+ 
+     int mask;
+     struct stat info;
+     jbyte *name;
+     jint code;
+     jmethodID mid;
+     jboolean executable, readOnly, success;
+     jclass cls; 
+ 
+ 	success = JNI_TRUE;    
+ 
+     /* get the current permissions */
+     name = getByteArray(env, target);
+     code = stat(name, &info);	
+     if (code == -1) {
+     	free(name);
+ 	    return JNI_FALSE;
+    }
+ 
+     /* is executable? */
+     executable = JNI_FALSE;
+     if ((info.st_mode & S_IXUSR) == S_IXUSR)
+ 	    executable = JNI_TRUE;
+ 	
+ 	/* is read-only? */
+ 	readOnly = JNI_FALSE;
+ 	if ((info.st_mode & S_IWUSR) != S_IWUSR)
+ 		readOnly = JNI_TRUE;
+ 		
+     /* set the values in ResourceAttribute */
+     cls = (*env)->GetObjectClass(env, obj);
+     mid = (*env)->GetMethodID(env, cls, "setExecutable", "(Z)V");
+     if (mid == 0) {
+ 	    success = JNI_FALSE;
+ 	} else {
+ 	    (*env)->CallVoidMethod(env, obj, mid, executable);
+     }
+     mid = (*env)->GetMethodID(env, cls, "setReadOnly", "(Z)V");
+     if (mid == 0) {
+ 	    success = JNI_FALSE;
+ 	} else {
+ 	    (*env)->CallVoidMethod(env, obj, mid, readOnly);
+     }
+     free(name);
+     return success;
+ 	  
+ }
*** ./plugins/org.eclipse.core.resources.sysv5/src/Makefile.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.core.resources.sysv5/src/Makefile	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,29 ----
+ #**********************************************************************
+ # Copyright (c) 2000, 2004 IBM Corporation and others.
+ # All rights reserved. This program and the accompanying materials 
+ # are made available under the terms of the Eclipse Public License v1.0
+ # which accompanies this distribution, and is available at
+ # http://www.eclipse.org/legal/epl-v10.html
+ #********************************************************************** 
+ #
+ # makefile for libcore.so
+ 
+ CORE.C = core.c
+ CORE.O = core.o
+ LIB_NAME = libcore.so
+ LIB_NAME_FULL = libcore_3_1_0.so
+ 
+ #Set this to be your OS type
+ OS_TYPE = sysv5
+ 
+ #Set this to be the location of your JRE
+ JAVA_HOME = /usr/java
+ 
+ JDK_INCLUDE = -I${JAVA_HOME}/include -I${JAVA_HOME}/include/unixware
+ 
+ core :
+ 	cc -KPIC -O -c $(JDK_INCLUDE) -o $(CORE.O) $(CORE.C)
+ 	cc -O -G -Wl,-h,$(LIB_NAME) -o $(LIB_NAME_FULL) $(CORE.O) -lc
+ 
+ clean :
+ 	rm *.o
*** ./plugins/org.eclipse.core.resources.sysv5/META-INF/MANIFEST.MF.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.core.resources.sysv5/META-INF/MANIFEST.MF	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,9 ----
+ Manifest-Version: 1.0
+ Bundle-ManifestVersion: 2
+ Bundle-Name: %sysv5FragmentName
+ Bundle-SymbolicName: org.eclipse.core.resources.sysv5
+ Bundle-Version: 3.1.0
+ Bundle-Vendor: %providerName
+ Fragment-Host: org.eclipse.core.resources;bundle-version="[3.1.0,4.0.0)"
+ Bundle-Localization: plugin
+ Eclipse-PlatformFilter: (osgi.os=sysv5)
*** ./plugins/org.eclipse.core.resources.sysv5/.project.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.core.resources.sysv5/.project	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,22 ----
+ <?xml version="1.0" encoding="UTF-8"?>
+ <projectDescription>
+ 	<name>org.eclipse.core.resources.sysv5</name>
+ 	<comment></comment>
+ 	<projects>
+ 	</projects>
+ 	<buildSpec>
+ 		<buildCommand>
+ 			<name>org.eclipse.pde.ManifestBuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 		<buildCommand>
+ 			<name>org.eclipse.pde.SchemaBuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 	</buildSpec>
+ 	<natures>
+ 		<nature>org.eclipse.pde.PluginNature</nature>
+ 	</natures>
+ </projectDescription>
*** ./plugins/org.eclipse.core.resources.sysv5/.classpath.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.core.resources.sysv5/.classpath	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,7 ----
+ <?xml version="1.0" encoding="UTF-8"?>
+ <classpath>
+ 	<classpathentry kind="src" path="src"/>
+ 	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins"/>
+ 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+ 	<classpathentry kind="output" path="bin"/>
+ </classpath>
*** ./plugins/org.eclipse.swt.gtk.sysv5.x86/META-INF/MANIFEST.MF.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.swt.gtk.sysv5.x86/META-INF/MANIFEST.MF	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,17 ----
+ Manifest-Version: 1.0
+ Fragment-Host: org.eclipse.swt; bundle-version="[3.0.0,4.0.0)"
+ Bundle-Name: %fragmentName
+ Bundle-Vendor: %providerName
+ Bundle-SymbolicName: org.eclipse.swt.gtk.sysv5.x86; singleton:=true
+ Bundle-Version: 3.2.1
+ Bundle-ManifestVersion: 2
+ Bundle-Localization: fragment
+ Export-Package: 
+  org.eclipse.swt.internal.accessibility.gtk; x-internal:=true,
+  org.eclipse.swt.internal.cairo; x-internal:=true,
+  org.eclipse.swt.internal.cde; x-internal:=true,
+  org.eclipse.swt.internal.gnome; x-internal:=true,
+  org.eclipse.swt.internal.gtk; x-internal:=true,
+  org.eclipse.swt.internal.mozilla; x-internal:=true
+ Eclipse-PlatformFilter: (& (osgi.ws=gtk) (osgi.os=sysv5) (osgi.arch=x86))
+ 
*** ./plugins/org.eclipse.swt.gtk.sysv5.x86/.project.osr6	Thu Feb 15 09:38:55 2007
--- ./plugins/org.eclipse.swt.gtk.sysv5.x86/.project	Thu Feb 15 09:38:55 2007
***************
*** 0 ****
--- 1,22 ----
+ <?xml version="1.0" encoding="UTF-8"?>
+ <projectDescription>
+ 	<name>org.eclipse.swt.gtk.sysv5.x86</name>
+ 	<comment></comment>
+ 	<projects>
+ 	</projects>
+ 	<buildSpec>
+ 		<buildCommand>
+ 			<name>org.eclipse.pde.ManifestBuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 		<buildCommand>
+ 			<name>org.eclipse.pde.SchemaBuilder</name>
+ 			<arguments>
+ 			</arguments>
+ 		</buildCommand>
+ 	</buildSpec>
+ 	<natures>
+ 		<nature>org.eclipse.pde.PluginNature</nature>
+ 	</natures>
+ </projectDescription>
*** ./features/org.eclipse.platform.launchers/library/motif/build.sh.osr6	Thu Sep 21 07:57:38 2006
--- ./features/org.eclipse.platform.launchers/library/motif/build.sh	Thu Feb 15 09:38:56 2007
***************
*** 47,52 ****
--- 47,61 ----
  		MOTIF_HOME=/usr
  		OUTPUT_DIR="../../bin/$defaultWS/$defaultOS/$defaultOSArch"
  		;;
+ 	"SCO_SV")
+ 		makefile="make_sysv5.mak"
+ 		defaultOS="sysv5"
+ 		defaultOSArch="x86"
+ 		defaultWS="motif"
+ 		X11_HOME=/usr/X11R6.1
+ 		MOTIF_HOME=/usr		
+ 		OUTPUT_DIR="../../bin/$defaultWS/$defaultOS/$defaultOSArch"
+ 		;;
  	"Linux")
  		makefile="make_linux.mak"
  		defaultOS="linux"
*** ./features/org.eclipse.platform.launchers/library/gtk/build.sh.osr6	Thu Sep 21 07:57:25 2006
--- ./features/org.eclipse.platform.launchers/library/gtk/build.sh	Thu Feb 15 09:38:56 2007
***************
*** 42,47 ****
--- 42,56 ----
  fi
  
  case $OS in
+ 	"SCO_SV")
+ 		makefile="make_sysv5.mak"
+ 		defaultOS="sysv5"
+ 		defaultWS="gtk"
+ 		defaultOSArch="x86"
+ 		OUTPUT_DIR="../../bin/$defaultWS/$defaultOS/$defaultOSArch"
+ 		PATH=/usr/ccs/bin:/usr/gnu/bin:$PATH
+ 		export PATH
+ 		;;
  	"Linux")
  		makefile="make_linux.mak"
  		defaultOS="linux"
***************
*** 127,139 ****
  export OUTPUT_DIR PROGRAM_OUTPUT DEFAULT_OS DEFAULT_OS_ARCH DEFAULT_WS
  
  # If the OS is supported (a makefile exists)
  if [ "$makefile" != "" ]; then
  	if [ "$extraArgs" != "" ]; then
! 		make -f $makefile $extraArgs
  	else
  		echo "Building $OS launcher. Defaults: -os $DEFAULT_OS -arch $DEFAULT_OS_ARCH -ws $DEFAULT_WS"
! 		make -f $makefile clean
! 		make -f $makefile all
  	fi
  else
  	echo "Unknown OS ($OS) -- build aborted"
--- 136,149 ----
  export OUTPUT_DIR PROGRAM_OUTPUT DEFAULT_OS DEFAULT_OS_ARCH DEFAULT_WS
  
  # If the OS is supported (a makefile exists)
+ [ "$MAKE" ] || MAKE=make
  if [ "$makefile" != "" ]; then
  	if [ "$extraArgs" != "" ]; then
! 		$MAKE -f $makefile $extraArgs
  	else
  		echo "Building $OS launcher. Defaults: -os $DEFAULT_OS -arch $DEFAULT_OS_ARCH -ws $DEFAULT_WS"
! 		$MAKE -f $makefile clean
! 		$MAKE -f $makefile all
  	fi
  else
  	echo "Unknown OS ($OS) -- build aborted"
*** ./features/org.eclipse.platform.launchers/library/gtk/make_sysv5.mak.osr6	Thu Feb 15 09:38:56 2007
--- ./features/org.eclipse.platform.launchers/library/gtk/make_sysv5.mak	Thu Feb 15 09:38:56 2007
***************
*** 0 ****
--- 1,63 ----
+ #*******************************************************************************
+ # Copyright (c) 2000, 2005 IBM Corporation and others.
+ # All rights reserved. This program and the accompanying materials
+ # are made available under the terms of the Eclipse Public License v1.0
+ # which accompanies this distribution, and is available at 
+ # http://www.eclipse.org/legal/epl-v10.html
+ # 
+ # Contributors:
+ #     IBM Corporation - initial API and implementation
+ #     Kevin Cornell (Rational Software Corporation)
+ #     Tom Tromey (Red Hat, Inc.)
+ #*******************************************************************************
+ 
+ # Makefile for creating the GTK eclipse launcher program.
+ #
+ # This makefile expects the utility "pkg-config" to be in the PATH.
+ 
+ # This makefile expects the following environment variables set:
+ #
+ # PROGRAM_OUTPUT  - the filename of the output executable
+ # DEFAULT_OS      - the default value of the "-os" switch
+ # DEFAULT_OS_ARCH - the default value of the "-arch" switch
+ # DEFAULT_WS      - the default value of the "-ws" switch
+ 
+ # Define the object modules to be compiled and flags.
+ CC=cc
+ OBJS = eclipse.o eclipseUtil.o eclipseShm.o eclipseConfig.o eclipseGtk.o
+ EXEC = $(PROGRAM_OUTPUT)
+ LIBS = `pkg-config --libs-only-L gtk+-2.0` -lgtk-x11-2.0 -lgdk_pixbuf-2.0 -lgobject-2.0 -lgdk-x11-2.0
+ CFLAGS = -O \
+ 	-KPIC \
+ 	-DLINUX \
+ 	-DMOZILLA_FIX \
+ 	-DDEFAULT_OS="\"$(DEFAULT_OS)\"" \
+ 	-DDEFAULT_OS_ARCH="\"$(DEFAULT_OS_ARCH)\"" \
+ 	-DDEFAULT_WS="\"$(DEFAULT_WS)\"" \
+ 	-I. \
+ 	-I.. \
+ 	`pkg-config --cflags gtk+-2.0`
+ 
+ all: $(EXEC)
+ 
+ eclipse.o: ../eclipse.c ../eclipseOS.h
+ 	$(CC) $(CFLAGS) -c ../eclipse.c -o eclipse.o
+ 
+ eclipseUtil.o: ../eclipseUtil.c ../eclipseUtil.h ../eclipseOS.h
+ 	$(CC) $(CFLAGS) -c ../eclipseUtil.c -o eclipseUtil.o
+ 
+ eclipseShm.o: ../eclipseShm.c ../eclipseShm.h ../eclipseOS.h
+ 	$(CC) $(CFLAGS) -c ../eclipseShm.c -o eclipseShm.o
+ 
+ eclipseConfig.o: ../eclipseConfig.c ../eclipseConfig.h ../eclipseOS.h
+ 	$(CC) $(CFLAGS) -c ../eclipseConfig.c -o eclipseConfig.o
+ 	
+ $(EXEC): $(OBJS)
+ 	$(CC) -o $(EXEC) $(OBJS) $(LIBS)
+ 
+ install: all
+ 	cp $(EXEC) $(OUTPUT_DIR)
+ 	rm -f $(EXEC) $(OBJS)
+ 
+ clean:
+ 	rm -f $(EXEC) $(OBJS)
